using RMYY_CallCenter_Api.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RMYY_CallCenter_Api.Dal
{
    /// <summary>
    /// 数据访问类:T_Sys_IVRWords
    /// </summary>
    public partial class T_Sys_IVRWords
    {
        public T_Sys_IVRWords()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_Id)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Sys_IVRWords");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(RMYY_CallCenter_Api.Model.T_Sys_IVRWords model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Sys_IVRWords(");
            strSql.Append("F_Title,F_GroupCode,F_Content,F_Type,F_StartTime,F_EndTime,F_Remark,F_IsState,F_CreateTime,F_CreateBy,F_IsDelete,F_Files)");
            strSql.Append(" values (");
            strSql.Append("@F_Title,@F_GroupCode,@F_Content,@F_Type,@F_StartTime,@F_EndTime,@F_Remark,@F_IsState,@F_CreateTime,@F_CreateBy,@F_IsDelete,@F_Files)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Title", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_GroupCode", SqlDbType.VarChar,50),
                    new SqlParameter("@F_Content", SqlDbType.NText),
                    new SqlParameter("@F_Type", SqlDbType.Int,4),
                    new SqlParameter("@F_StartTime", SqlDbType.DateTime),
                    new SqlParameter("@F_EndTime", SqlDbType.DateTime),
                    new SqlParameter("@F_Remark", SqlDbType.NText),
                    new SqlParameter("@F_IsState", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_CreateBy", SqlDbType.VarChar,50),
                    new SqlParameter("@F_IsDelete", SqlDbType.Bit,1),
                    new SqlParameter("@F_Files", SqlDbType.NVarChar,-1)};
            parameters[0].Value = model.F_Title;
            parameters[1].Value = model.F_GroupCode;
            parameters[2].Value = model.F_Content;
            parameters[3].Value = model.F_Type;
            parameters[4].Value = model.F_StartTime;
            parameters[5].Value = model.F_EndTime;
            parameters[6].Value = model.F_Remark;
            parameters[7].Value = model.F_IsState;
            parameters[8].Value = model.F_CreateTime;
            parameters[9].Value = model.F_CreateBy;
            parameters[10].Value = model.F_IsDelete;
            parameters[11].Value = model.F_Files;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(RMYY_CallCenter_Api.Model.T_Sys_IVRWords model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sys_IVRWords set ");
            strSql.Append("F_Title=@F_Title,");
            strSql.Append("F_GroupCode=@F_GroupCode,");
            strSql.Append("F_Content=@F_Content,");
            strSql.Append("F_Type=@F_Type,");
            strSql.Append("F_StartTime=@F_StartTime,");
            strSql.Append("F_EndTime=@F_EndTime,");
            strSql.Append("F_Remark=@F_Remark,");
            strSql.Append("F_IsState=@F_IsState,");
            strSql.Append("F_CreateTime=@F_CreateTime,");
            strSql.Append("F_CreateBy=@F_CreateBy,");
            strSql.Append("F_IsDelete=@F_IsDelete,");
            strSql.Append("F_Files=@F_Files");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Title", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_GroupCode", SqlDbType.VarChar,50),
                    new SqlParameter("@F_Content", SqlDbType.NText),
                    new SqlParameter("@F_Type", SqlDbType.Int,4),
                    new SqlParameter("@F_StartTime", SqlDbType.DateTime),
                    new SqlParameter("@F_EndTime", SqlDbType.DateTime),
                    new SqlParameter("@F_Remark", SqlDbType.NText),
                    new SqlParameter("@F_IsState", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_CreateBy", SqlDbType.VarChar,50),
                    new SqlParameter("@F_IsDelete", SqlDbType.Bit,1),
                    new SqlParameter("@F_Files", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_Id", SqlDbType.Int,4)};
            parameters[0].Value = model.F_Title;
            parameters[1].Value = model.F_GroupCode;
            parameters[2].Value = model.F_Content;
            parameters[3].Value = model.F_Type;
            parameters[4].Value = model.F_StartTime;
            parameters[5].Value = model.F_EndTime;
            parameters[6].Value = model.F_Remark;
            parameters[7].Value = model.F_IsState;
            parameters[8].Value = model.F_CreateTime;
            parameters[9].Value = model.F_CreateBy;
            parameters[10].Value = model.F_IsDelete;
            parameters[11].Value = model.F_Files;
            parameters[12].Value = model.F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_IVRWords ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_Idlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_IVRWords ");
            strSql.Append(" where F_Id in (" + F_Idlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public RMYY_CallCenter_Api.Model.T_Sys_IVRWords GetModel(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_Id,F_Title,F_GroupCode,F_Content,F_Type,F_StartTime,F_EndTime,F_Remark,F_IsState,F_CreateTime,F_CreateBy,F_IsDelete,F_Files from T_Sys_IVRWords ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            RMYY_CallCenter_Api.Model.T_Sys_IVRWords model = new RMYY_CallCenter_Api.Model.T_Sys_IVRWords();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public RMYY_CallCenter_Api.Model.T_Sys_IVRWords DataRowToModel(DataRow row)
        {
            RMYY_CallCenter_Api.Model.T_Sys_IVRWords model = new RMYY_CallCenter_Api.Model.T_Sys_IVRWords();
            if (row != null)
            {
                if (row["F_Id"] != null && row["F_Id"].ToString() != "")
                {
                    model.F_Id = int.Parse(row["F_Id"].ToString());
                }
                if (row["F_Title"] != null)
                {
                    model.F_Title = row["F_Title"].ToString();
                }
                if (row["F_GroupCode"] != null)
                {
                    model.F_GroupCode = row["F_GroupCode"].ToString();
                }
                if (row["F_Content"] != null)
                {
                    model.F_Content = row["F_Content"].ToString();
                }
                if (row["F_Type"] != null && row["F_Type"].ToString() != "")
                {
                    model.F_Type = int.Parse(row["F_Type"].ToString());
                }
                if (row["F_StartTime"] != null && row["F_StartTime"].ToString() != "")
                {
                    model.F_StartTime = DateTime.Parse(row["F_StartTime"].ToString());
                }
                if (row["F_EndTime"] != null && row["F_EndTime"].ToString() != "")
                {
                    model.F_EndTime = DateTime.Parse(row["F_EndTime"].ToString());
                }
                if (row["F_Remark"] != null)
                {
                    model.F_Remark = row["F_Remark"].ToString();
                }
                if (row["F_IsState"] != null && row["F_IsState"].ToString() != "")
                {
                    model.F_IsState = int.Parse(row["F_IsState"].ToString());
                }
                if (row["F_CreateTime"] != null && row["F_CreateTime"].ToString() != "")
                {
                    model.F_CreateTime = DateTime.Parse(row["F_CreateTime"].ToString());
                }
                if (row["F_CreateBy"] != null)
                {
                    model.F_CreateBy = row["F_CreateBy"].ToString();
                }
                if (row["F_IsDelete"] != null && row["F_IsDelete"].ToString() != "")
                {
                    if ((row["F_IsDelete"].ToString() == "1") || (row["F_IsDelete"].ToString().ToLower() == "true"))
                    {
                        model.F_IsDelete = true;
                    }
                    else
                    {
                        model.F_IsDelete = false;
                    }
                }
                if (row["F_Files"] != null)
                {
                    model.F_Files = row["F_Files"].ToString();
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_Id,F_Title,F_GroupCode,F_Content,F_Type,F_StartTime,F_EndTime,F_Remark,F_IsState,F_CreateTime,F_CreateBy,F_IsDelete,F_Files ");
            strSql.Append(" FROM T_Sys_IVRWords ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_Id,F_Title,F_GroupCode,F_Content,F_Type,F_StartTime,F_EndTime,F_Remark,F_IsState,F_CreateTime,F_CreateBy,F_IsDelete,F_Files ");
            strSql.Append(" FROM T_Sys_IVRWords ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Sys_IVRWords ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_Id desc");
            }
            strSql.Append(")AS Row, T.*  from T_Sys_IVRWords T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

      

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
